import { BaseSelectProps } from '@mui/material'
import { useEffect, useState } from 'react'
import { Controller } from 'react-hook-form'
import axios from '../../../../config/axios'
import { MultiSelect } from '../../../Input'

type MultiQuotaSelectorProps = {
  control: any
  name?: string
  label: string
  filters?: { courseId: number }
  required?: boolean
  onChange?: (value: any) => void
  allowAll?: boolean
  error?: boolean
  helperText?: string
  api?: string
} & BaseSelectProps
export default function MultiQuotaSelector(props: MultiQuotaSelectorProps) {
  const {
    control,
    onChange,
    name,
    required = false,
    label,
    multiple = false,
    filters,
    value,
    allowAll = true,
    api = '/square/quotas',
  } = props
  const [options, setOptions] = useState([])
  const [prevCourseId, setPrevCourseId] = useState(null)
  const handleOpen = () => {
    if (filters) {
      if (filters.courseId && filters.courseId !== prevCourseId) {
        setOptions([])
        axios
          .get(api, {
            params: filters,
          })
          .then((response) => {
            setOptions(
              api == '/square/quotas' ? response.data : response.data.quotas,
            )
            setPrevCourseId(filters.courseId)
          })
          .catch((error) => {
            console.error('Error fetching data from the API:', error)
          })
      }
    } else if (options.length === 0) {
      axios
        .get(api)
        .then((response) => {
          setOptions(
            api == '/square/quotas' ? response.data : response.data.quota,
          )
        })
        .catch((error) => {
          console.error('Error fetching data from the API:', error)
        })
    }
  }
  useEffect(() => {
    if (props?.value && props.value != 'all') {
      handleOpen()
    }
  }, [props.value])
  const handleOptions =
    options.length > 0
      ? [
          ...(allowAll ? [{ value: 'all', label: 'All' }] : []),
          ...options.map((item) => ({
            label: `${item.name}`,
            value: `${item.id}`,
          })),
        ]
      : allowAll
      ? [{ value: 'all', label: 'All' }]
      : []

  return (
    <Controller
      name={name}
      control={control}
      render={({ field, fieldState: { error } }) => (
        <MultiSelect
          name={name}
          label={label}
          required={required}
          options={handleOptions}
          onOpen={handleOpen}
          onChange={onChange ?? field.onChange}
          value={value ?? field?.value}
          error={!!error}
          helperText={error?.message}
        />
      )}
    />
  )
}
